<template>
<section>
        <h2>Administration des logos</h2>
  <v-card>
    <div class="col-12 row">
      <img class="img col-4" :src="files.logo1" alt="logo 1" />
      <div class="col-8">
        <v-file-input 
          label="Logo 1" 
          :rules="rules"
          chips 
          show-size 
          @change="e=>changeFile('logo1', e)" 
          prepend-icon="mdi-camera"
        />
        <div class="row justify-content-start">
        <v-btn @click="deleteFile('logo1')">
          <v-icon>mdi-delete</v-icon>
        </v-btn>
        </div>
      </div>
    </div>
    <div class="col-12 row">
      <img class="img col-4" :src="files.logo2" alt="logo 2" />
      <div class="col-8">
        <v-file-input 
          label="Logo 2"
          :rules="rules"
          chips 
          show-size 
          v-on:change="e=>changeFile('logo2', e)" 
          prepend-icon="mdi-camera"  
        />
        <div class="row justify-content-start">
        <v-btn @click="deleteFile('logo2')">
          <v-icon>mdi-delete</v-icon>
        </v-btn>
        </div>
      </div>
    </div>
    <div class="row justify-content-center">
      <button class="btn btn-primary mb-2" @click="submitFiles">Soumettre</button>
    </div>
  </v-card>
</section>
</template>
<script lang="ts">
import { Component, Vue, Watch } from "vue-property-decorator";
import { mapState } from "vuex";
import toBase64 from "../../../utils/imgEncode";
import { Settings } from "../../../transport/Settings";
import SettingsService from "../../../services/settingsService";

@Component({
  computed: {
    ...mapState(["settings"])
  }
})
export default class AdminLogo extends Vue {
  private files: Settings = {
    logo1: null,
    logo2: null
  };

rules= [
      value => !value || (value.type === 'image/png' || value.type === 'image/jpeg' || value.type === 'image/bmp') || 'Le fichier doit être au format png, jpeg ou bmp',
      
    ]

  @Watch("settings", { deep: true, immediate: true })
  onSettingsChange() {
    if (this.$store.state.settings) {
      this.files.logo1 = this.$store.state.settings.logo1;
      this.files.logo2 = this.$store.state.settings.logo2;
    }
  }

  changeFile(logo, e) {
    console.log(e)
    if(this.rules[0](e) !== 'Le fichier doit être au format png, jpeg ou bmp'){
      toBase64(e).then(res => (this.files[logo] = res));
    }
    
  }

  deleteFile(logo) {
    this.files[logo] = null;
  }

  submitFiles() {
    new SettingsService()
      .postSetting(this.files)
      .then(() => this.$store.dispatch("getSettings"));
  }
}
</script>
 <style>
.img {
  max-width: 20%;
}
</style>
 